%define pkg muse
%bcond_without xemacs

Name: emacs-common-muse
Version: 3.20
Release: 4%{?dist}
Summary: Emacs Muse is an authoring and publishing environment for Emacs
Group: Applications/Editors
License: GPLv2+
URL: http://www.mwolson.org/projects/MuseMode.html           
Obsoletes: muse = 3.02.6b
Requires(pre): /sbin/install-info 
Requires(post): /sbin/install-info 

BuildArch: noarch
Source0: http://download.gna.org/muse-el/%{pkg}-%{version}.tar.gz
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
BuildRequires: emacs emacs-el
BuildRequires: texinfo-tex
BuildRequires: tex(latex)
%if %{with_xemacs}
BuildRequires: xemacs xemacs-devel xemacs-packages-extra
%endif

%description 
Muse is an authoring and publishing environment for (X)Emacs. It
simplifies the process of writings documents and publishing them to
various output formats. Muse uses a very simple Wiki-like format as
input.  Muse consists of two main parts: an enhanced text-mode for
authoring documents and navigating within Muse projects, and a set of
publishing styles for generating different kinds of output.

This package contains the files common to both the Emacs and XEmacs
installations of Muse. You need to install either (or both) of
emacs-%{pkg} and xemacs-%{pkg} to use Muse.

%package -n emacs-%{pkg}
Summary: Compiled Muse lisp files for Emacs
Group: Applications/Editors
Requires: %{name} = %{version}-%{release}
Requires: emacs(bin) >= %{_emacs_version}
Requires: tex(latex)

%description -n emacs-%{pkg}
This package contains the files required to use Muse with Emacs.

%package -n emacs-%{pkg}-el
Summary: Muse lisp source files for Emacs
Group: Applications/Editors
Requires: emacs-%{pkg} = %{version}-%{release}

%description -n emacs-%{pkg}-el
This package contains the source lisp files for Muse for Emacs.

%if %{with_xemacs}
%package -n xemacs-%{pkg}
Summary: Compiled Muse lisp files for XEmacs
Group: Applications/Editors
Requires: %{name} = %{version}-%{release}
Requires: xemacs >= %{_xemacs_version}
Requires: tex(latex)

%description -n xemacs-%{pkg}
This package contains the files required to use Muse with XEmacs.

%package -n xemacs-%{pkg}-el
Summary: Muse lisp source files for XEmacs
Group: Applications/Editors
Requires: xemacs-%{pkg} = %{version}-%{release}

%description -n xemacs-%{pkg}-el
This package contains the source lisp files for Muse for XEmacs.
%endif

%prep
%setup -q -n %{pkg}-%{version}

%build 
# Note that %{_smp_mflags} causes make to hang sometimes here.
make all doc examples experimental

%install
rm -rf %{buildroot}
mkdir -p %{buildroot}%{_infodir}

make install DESTDIR=%{buildroot} PREFIX=%{_usr} INFODIR=%{buildroot}%{_infodir}

# This shouldn't be necessary, but currently the package makefiles don't 
# install the compiled lisp files
(cd experimental ; make install PREFIX=%{buildroot}/%{_usr})

# Create startup file.
mkdir -p %{buildroot}/%{_emacs_sitestartdir}

cat > muse-init.el << EOF
;; Load muse-mode
(require 'muse-mode)

;; Load publishing styles
(require 'muse-html)
(require 'muse-latex)
(require 'muse-texinfo)
(require 'muse-docbook)
(require 'muse-wiki)
(require 'muse-journal)
EOF

cp muse-init.el %{buildroot}/%{_emacs_sitestartdir}

# Xemacs files
%if %{with_xemacs}
make clean
make lisp contrib autoloads experimental EMACS=xemacs SITEFLAG=-no-site-file 
make install-bin ELISPDIR=%{buildroot}/%{_xemacs_sitelispdir}/%{pkg}

# This shouldn't be necessary, but currently the package makefiles don't 
# install the compiled lisp files
(cd experimental ; make install ELISPDIR=%{buildroot}/%{_xemacs_sitelispdir}/%{pkg})

mkdir -p %{buildroot}/%{_xemacs_sitestartdir}
cp muse-init.el %{buildroot}/%{_xemacs_sitestartdir}
%endif 

# Remove info dir creating by make install
rm -f %{buildroot}/usr/share/info/dir

# Fix files we package as documentation to not be executeable
for i in examples contrib/pyblosxom scripts ; do 
  find $i -type f -perm +111 -exec chmod -x {} \;
done

# Fix file encoding
pushd examples/johnw
iconv -f ISO-8859-1 -t UTF8 muse-init.el > muse-init.el.utf8 && mv muse-init.el.utf8 muse-init.el
popd

%clean
rm -rf %{buildroot}

%post
/sbin/install-info %{_infodir}/muse %{_infodir}/dir 2>/dev/null || :

%preun
if [ $1 -eq 0 ]; then
  /sbin/install-info --delete %{_infodir}/muse %{_infodir}/dir 2>/dev/null || :
fi

%files
%defattr(-,root,root,-)
%doc README NEWS AUTHORS ChangeLog ChangeLog.1 ChangeLog.2 ChangeLog.3 
%doc examples etc contrib/pyblosxom scripts
%doc %{_infodir}/muse.gz

%files -n emacs-%{pkg}
%defattr(-,root,root,-)
%{_emacs_sitelispdir}/%{pkg}/*.elc
%{_emacs_sitelispdir}/%{pkg}/contrib/*.elc
%{_emacs_sitelispdir}/%{pkg}/experimental/*.elc
%{_emacs_sitestartdir}/muse-init.el
%dir %{_emacs_sitelispdir}/%{pkg}
%dir %{_emacs_sitelispdir}/%{pkg}/contrib
%dir %{_emacs_sitelispdir}/%{pkg}/experimental

%files -n emacs-%{pkg}-el
%defattr(-,root,root,-)
%{_emacs_sitelispdir}/%{pkg}/*.el
%{_emacs_sitelispdir}/%{pkg}/experimental/*.el
%{_emacs_sitelispdir}/%{pkg}/contrib/*.el

%if %{with_xemacs}
%files -n xemacs-%{pkg}
%defattr(-,root,root,-)
%{_xemacs_sitelispdir}/%{pkg}/*.elc
%{_xemacs_sitelispdir}/%{pkg}/contrib/*.elc
%{_xemacs_sitelispdir}/%{pkg}/experimental/*.elc
%{_xemacs_sitestartdir}/muse-init.el
%dir %{_xemacs_sitelispdir}/%{pkg}
%dir %{_xemacs_sitelispdir}/%{pkg}/contrib
%dir %{_xemacs_sitelispdir}/%{pkg}/experimental

%files -n xemacs-%{pkg}-el
%defattr(-,root,root,-)
%{_xemacs_sitelispdir}/%{pkg}/*.el
%{_xemacs_sitelispdir}/%{pkg}/contrib/*.el
%{_xemacs_sitelispdir}/%{pkg}/experimental/*.el
%endif

%changelog
* Fri Jan 13 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.20-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Tue Feb 08 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.20-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Tue Feb  8 2010 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.20-2
- Spec file macro fixes

* Tue Feb  8 2010 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.20-1
- Update to version 3.20
- Modify spec file to use (X)Emacs packaging macros

* Fri Jul 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.12-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Tue Feb 24 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 3.12-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Sun Feb  3 2008 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.12-1
- Update to version 3.12
- Cleanup spec file to comply with emacs add-on packaging guidelines
- Fix file encodings
- Cleanup the make install variables

* Sat Aug 25 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.11-1
- Update to version 3.11

* Fri Aug 17 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.10-1
- Update to release 3.10

* Sat Aug  4 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.03-4
- Clarify license

* Thu Jul 12 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.03-3
- Added patch with various fixes from upstream maintainer to fix issues raised
  in BZ 247369

* Mon Jul  2 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.03-2
- Add BuildRequires for tetex-latex so pdf files get built

* Mon Jul  2 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.03-1
- Update to version 3.03
- Fix up the sub-package Requires to depend on release-version
- Correct location of installed xemacs files

* Sat Feb 10 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.93-5
- Bump release

* Sat Feb 10 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.93-4
- Fix error in info file naming (BZ 227459)

* Sun Jan  7 2007 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.93-3
- Fix directory ownership of contrib and experimental directories
- Release bump

* Fri Dec 29 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.93-1
- Update to version 3.02.93
- Some spec file cleanups
- Update the BuildRequires to pull in xemacs-packages-extra
- Add BuildRequires texinfo-tex so that the QuickStart.pdf file is built
- Add scripts directory to main package 
- Build autoload and contrib files for xemacs package

* Mon Aug 28 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.92-5
- Fix up ChangeLog.[1-3] references in doc

* Sun Aug 27 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.92-2
- Fix erroneous setup directory (remove -n)

* Sun Aug 27 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.92-1
- Update to 3.02.92 (3.03 RC2)

* Thu Jun  8 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.91-4
- Package experimental and contrib files
- Ensure all doc files are non-executable
- Fix up doc files

* Thu Jun  8 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.91-3
- Correct directory name in setup

* Thu Jun  8 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.91-2
- Bump release
- Correct email addresses in changelog entries

* Thu Jun  8 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.91-1
- Update package to latest development release
- Re-enable XEmacs build

* Mon May 22 2006 Jonathan G. Underwood <jonathan.underwood@gmail.com> - 3.02.6b-5
- Rename package to emacs-common-muse

* Sun Apr 23 2006 Jonathan Underwood <jonathan.underwood@gmail.com> - 3.02.6b-4
- Update to version 3.02.6b

* Sun Mar  5 2006 Jonathan Underwood <jonathan.underwood@gmail.com> - 3.02.6a-3
- Added BuildRequires: texinfo
- Remove info dir from buildroot (created by make install)

* Fri Feb 10 2006 Jonathan Underwood <jonathan.underwood@gmail.com> - 3.02.6a-1
- Initial package build

